TITLE Freehafer's read disk boot sector program
;
;					Bibliography
;
;	1. 	Port sound help is found in The Revolutionary Guide To Assembly Language,
;		Maljugin, Wrox Press, UK, 1993, page 504. 
;
;.......................................................................
;					; message output macro
;.......................................................................
msg	MACRO	msgout
	mov AH, 09h			; function 09h
	lea DX, msgout		; DX holds message
	int 21h 			; display string interupt
ENDM
;.......................................................................
.MODEL small		      ; directive placing all memory in one segment
;.......................................................................
;
;.............................; stack segment...........................
StackSeg segment stack	      ; stack segment begins
StackSeg ends		      ; stack segment ends
;.......................................................................
;
;.............................; data segment............................
DataSeg segment

	NUM			DW ?

	DIRENTRY STRUC			; root directory structure							offset	size
		deFILENAME	db 0,0,0,0	; 0 never used; 05h = 0E5h file deleted; 					00h		4
				db 0,0,0,0	; 02Eh deCLUSTNUM starting # of cluster for root directory		
		deFILEEXT	db 0,0,0	; file extension									09h		3
		deATRIB	db ?		; read only,hidden,system,vol label,subdir.,new or modified		0Bh		
		deRESERV	db 0,0,0,0	; not used											
			  db 0,0,0,0,0,0	; not used										
		deTIME	dw ?		; time directory created							
		deDATE	dw ?		; date directory created							
		deCLUSTNUM	dw ?		; starting cluster of directory or file					
		deFILESIZE	dd ?		; file size in bytes	
		zyx		db 16352 dup(0);						
	DIRENTRY ENDS
	
	BOOT STRUC				;							offset     size
		bsJUMP 	db 0,0,0	; jump to boot code loads operating sys.	offset 00h 3
		bsOEM 	db 0,0,0,0	;
				db 0,0,0,0	; Original Equipment Manufacturer co.	offset 03h 8
						; start of BIOS PARAMETER BLOCK*******
		bsSECTSIZE 	dw ?		; sector size of bytes per cluster		offset 0Bh 2
		bsCLUSTSIZE db ?		; sectors per cluster				offset 0Dh 1
		bsRESSECT 	dw ?		; reserved sectors 0 to 1 before FAT	offset 0Eh 2
		bsFATCNT 	db ?		; # of FAT's usually 2				offset 10h 1
		bsROOTSIZE 	dw ?		; maximum # of directory entries each 32b	offset 11h 2
		bsTOTALSECT dw ?		; total # of sectors on drive			offset 13h 2
		bsMEDIA 	db ?		; 1.44Mb = 0F0h					offset 15h 1
		bsFATSIZE	dw ?		; # of sectors in one FAT			offset 16h 2
		bsTRACKSET	dw ?		; # sectors per track				offset 18h 2
		bsHEADCNT	dw ?		; # or read & write heads			offset 1Ah 2
		bsHIDENSECT	dd ?		; # of hiden sectors				offset 1Ch 2
		bsHUGESECT	dd ?		; if (bsTOTALSECT = 0) # of sectors		offset 1Eh 2
						; end of BIOS PARAMETER BLOCK********	offset 20h 4
		bsDRIVENUM	db ?		; 80h if a boot drive otherwise = 0		offset 24h 1
		bsRESERV	db ?		; reserved not used				offset 25h 1
		bsBOOTSIGN	db ?		; extended boot signature = 29h		offset 26h 1
		bsVOLID	dd ?		; volume serial number				offset 27h 4
		bsVOLABEL	db 0,0,0,0,0
			DB 0,0,0,0,0,0	; 11 character volume label			offset 2Bh 0Bh
		bsFILESTYPE db 0,0,0,0
			DB 0,0,0,0		; FAT 12 or FAT 16				offset 36h 8
		xyz		db 448 DUP(0);start of boot program and data		offset 3Eh 448
	BOOT ENDS 

	btSTRUC		BOOT <>	; structure
	rtSTRUC		DIRENTRY<>	; structure

;fat page declarations
	ppmsg			DB " + (65536 * ",'$'
	eqmsg			DB ") = ",0Ah,0Dh,'$'
	CRLF			DB ".",0Ah,0Dh,'$'	; period, carriage return, and line feed
	bjmsg			DB "     Jump = ",'$'						;?
	boemsg		DB "     Original equipment manufacturer  = ",'$'	;?
	bbiosmsg		DB ".          *****START BIOS PARAMETER BLOCK",'$'
	bSSmsg		DB "     Bytes per sector = ",'$'
	bCSmsg		DB "     Number of sectors per cluster = ",'$'
	bRSmsg		DB "     Number of reserved sectors before FAT = ",'$'
	bFCmsg		DB "     Fat count = ",'$'
	bRTSmsg		DB "     Root size or maximum # of directory entries = ",'$'
	bTOTmsg		DB "     Total # of sectors on drive a: = ",'$'
	bMmsg			DB "     Media = ",'$'
	bFSmsg		DB "     Fatsize = ",'$'
	bTSmsg		DB "     Number of sectors per track = ",'$'
	bHCmsg		DB "     Number of heads per track = ",'$'
	bHIDSmsg		DB "     Hidden sectors = ",'$'				;?
	bHUGSmsg		DB "     Huge sectors = ",'$'					;?
	bebiosmsg		DB ") = *****END BIOS PARAMETER BLOCK",'$'
	bDNmsg		DB "     Drive number = ",'$'
	bBSmsg		DB "     Boot sign = ",'$'
	bVIDmsg		DB "     Volume ID = ",'$'					;?
	bVLmsg		DB "     Volume label of a: = ",'$'		
	bFTmsg		DB "     Files type of a: = ",'$'
	bjumpa		DB 0,0,0,'$'
	boema			DB 0,0,0,0,0,0,0,0,'$'
	blabela		DB 0,0,0,0,0,0,0,0,0,0,0,'$'
	bfileta		DB 0,0,0,0,0,0,0,0,'$'
	hexa			DB 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70
	DASHmsg		DB "-",'$'
	HEXmsg		DB " or hexadecimal serial # = ", '$'
	HSN			DW 0
	LSN			DW 0

;root directory declarations
	rFNmsg		DB "     Root directory name = ",'$'
	rFEmsg		DB "     File extension = ",'$'
	rFAmsg		DB "     Byte value representation of file attribute = ",'$'
	rDTmsg		DB "     Word value representation of directory time = ",'$'
	rDDmsg		DB "     Word value representation of directory date = ",'$'
	rCNmsg		DB "     Cluster number = ",'$'
	rFSmsg		DB "     File size = ",'$'
	rMONTHmsg		DB "          Month = ",'$'
	rDAYmsg		DB "     Day = ",'$'
	rYEARmsg		DB "     Year = ",'$'
	rHOURmsg		DB "          Hour = ",'$'
	rMINUTEmsg		DB "     Minute = ",'$'
	rSECONDmsg		DB "     Second = ",'$'
	ATRROmsg		DB "          Read only (1 = yes, 0 = no) = ",'$'
	ATRHmsg		DB '          Hidden        "        "    = ','$'
	ATRSYSmsg		DB '          System        "        "    = ','$'
	ATRVLmsg		DB '          Volume label  "        "    = ','$'
	ATRSDmsg		DB '          Subdirectory  "        "    = ','$'
	ATRNMmsg		DB "          New or modified (1 = yes, 0 = archive) = ",'$'
	slash			DB "     ---",'$'
	firstsecroo		DB "     First sector of root directory = ",'$'
	rootsizeby		DB "     Size of root directory in bytes = ",'$'
	rootsizese		DB "     Size of root directory in sectors = ",'$'
	rata			DB 0,'$'
	rfnamea		DB 0,0,0,0,0,0,0,0,'$'
	rfilexta		DB 0,0,0,'$'
	YR			DW 0
	FSECOFROOT		DW 0
	SIZEROOTBYTES	DW 0
	SIZEROOTSEC		DW 0

; title page
	CW			DB 0Ah,0Dh,"          (C)2002 Inniea Publishing Company.",0Ah,0Dh,0Ah,0Dh,"                                                ",'$'
	RN			DB "R",153,142,"K NOG!",'$'     
	TMessage		DB "     Freehafer's Floppy A:\ Analyzer Program.", 0Ah,0Dh,"     Look at the FAT, root directory, & sector counts of A:\",'$'
	TEMessage		DB 0Ah,0Dh,0Ah,0Dh,"     Hit the R or r key to look at the root directory.",0Ah,0Dh,0Ah,0Dh,"     Hit the F or f key to look at the file allocation table.",0Ah,0Dh,0Ah,0Dh,"     Hit the S or s key to look at sector counts on the floppy.",0Ah,0Dh,0Ah,0Dh,"     Hit the T or t key to see this page again.",0Ah,0Dh,0Ah,0Dh,"     Hit any other key to exit this program.",0Ah,0Dh,0Ah,0Dh,'$'    
	Ready			DB 0Ah,0Dh,"     Hit the R, r, F, f, S, s, T, or t key to see another page!",0Ah,0Dh,"     Hit any other key to exit!",'$'
	RMessage		DB "     This is a reading from the root directory of A:\!",0Ah,0Dh,0Ah,0Dh,'$'
	FMessage		DB "     This is a structured reading for the FAT of A:\!",0Ah,0Dh,0Ah,0Dh,'$'
	SMessage		DB "     This is a look at the sector counts of A:\!",0Ah,0Dh,0Ah,0Dh,'$'
	freq  		DW      0,280,800,988,880,784,699,659,587,523;last on list is first out
	enoq			DB 0Ah,0Dh,0Ah,0Dh,"     You did not hit either the R, r, F, f, S, s, T, or t key.",0Ah,0Dh,"     You chose to exit!",0Ah,0Dh,'$'

; sector page
	INOUT			DB "       Inputs:  function AH = 36h, drive DL = 1h, call INT 21h; ",0Ah,0Dh,"       Outputs: register AX = sectors per cluster, ",0Ah,0Dh,"                   ''    BX = free clusters, ",0Ah,0Dh,"                   ''    CX = bytes per sector, ",0Ah,0Dh,"                   ''    DX = total clusters on disk.",0Ah,0Dh,0Ah,0Dh,'$'
	LINE			DB "       *******       *******       *******       *******",0Ah,0Dh,0Ah,0Dh,'$'
	spc			DW 0
	strspc		DB "                 The sectors per cluster on disk a: = ",'$'
	bps			DW 0
	strbps		DB "                    The bytes per sector on disk a: = ",'$'
	bpc			DW 0
	strbpc		DB "                   The bytes per cluster on disk a: = ",'$'
	tnumclus		DW 0
	strtnumclus		DB "            The total number of clusters on disk a: = ",'$'
	freeclus		DW 0
	strfreeclus		DB "       The total number of free clusters on disk a: = ",'$'
	strusedclus		DB "       The total number of used clusters on disk a: = ",'$'

;.......................................................................
DataSeg ends		      	; data segment ends	
;.......................................................................
;
;...................................; code segment begins...............
CodeSeg segment  
;.......................................................................
;
;...................................; tell assembler which segment is in what register
assume cs:CodeSeg, ds:DataSeg, ss:StackSeg 
;.......................................................................
;              
start:     		            	; begin algorithm
;........................................................................
;						; put data segment in ds
;........................................................................
	mov AX, DataSeg			; base address
	mov DS, AX				; of data segment
;........................................................................
;						; fill the structure while reading sector 0
;........................................................................
	mov AL, 0				; drive a:
	mov CX, 1				; number of sectors to read
	mov DX, 0				; beginning sector
	mov BX, offset btSTRUC		; address of FAT buffer
	int 25h				; absolute disk read interrupt
	pop DX				; discard extra word from stack
	jc qerror				; jump if error
;........................................................................
;						; for a 12 disk bit read FAT
;........................................................................
	mov AX, 3				; the first file's cluster
	mov SI, AX				; SI = AX * 1.5
	shr SI, 1				;
	add SI, AX				; 
	mov DX, WORD PTR DS:[BX+SI]	; read a word from FAT
	test AX, 1				; is the cluster index even
	jnz qneven_cluster		; not even
	and DX, 0000111111111111b	; even
	jmp qcontinue			;
qneven_cluster:
	mov CL, 4				; not even
	shr DX, CL				;
	jmp qcontinue			;
;........................................................................
;						; for a 16 bit disk read FAT
;........................................................................
	mov SI, 3				; the first file's cluster from root directory
	shr SI, 1				;
	mov DX, WORD PTR DS:[BX+SI]	; read a word from FAT
;........................................................................
qcontinue:
qerror:					
qend:
;........................................................................
;						; find and read the root
;........................................................................
	mov AX, btSTRUC.bsFATSIZE	; AX = btSTRUC.bsFATSIZE
	mov CL, btSTRUC.bsFATCNT	; CL = btSTRUC.bsFATCNT
	xor CH, CH				; CL = 0
	mul CX				; AX:DX or AX = CX * AX = btSTRUC.bsFATCNT * btSTRUC.bsFATSIZE
	mov BX, btSTRUC.bsRESSECT	; BX = btSTRUC.bsRESSECT
	add BX, AX				; BX = btSTRUC.bsRESSECT + (btSTRUC.bsFATCNT * btSTRUC.bsFATSIZE) 
	mov FSECOFROOT,BX			; FSECOFROOT + BX = 1st sector of root
	mov AX, btSTRUC.bsROOTSIZE	; AX = btSTRUC.bsROOTSIZE = maximum # root entries
	mov CX, 32				; CX = 32
	mul CX				; AX:DX or AX = 32 * btSTRUC.bsROOTSIZE 
	mov SIZEROOTBYTES, AX		; SIZEROOTBYTES = AX = size of root in bytes
	mov CX, btSTRUC.bsSECTSIZE	; CX = btSTRUC.bsSECTSIZE
	div CX				; AX:DX or AX = (32 * btSTRUC.bsROOTSIZE) / btSTRUC.bsSECTSIZE 
	mov SIZEROOTSEC, AX		; SIZEROOTSEC = AX = size of root in sectors 
	mov CX, AX				; CX = root length in sectors to be read
	mov DX, BX				; DX = 1st sector
	mov AL, 0				; drive a:
	mov BX, offset rtSTRUC		; address of the root structure
	int 25h				; read sector
	pop DX				; discard extra word from stack
;.......................................................................
;						; get disk free space
;.......................................................................
	mov AH, 36h				; get disk free space function
	mov DL, 1h				; drive a: = 1
	int 21h				; call interrupt
	mov spc, AX				; sectors per cluster
	mov bps, CX				; bytes per sector
	mov freeclus, BX			; total free clusters
	mov tnumclus, DX			; total number of clusters
;........................................................................
;						; OUTPUTS
;........................................................................
titlepage:
;						; display title page
;........................................................................
;						; clear screen
;........................................................................
	mov AH, 2				; function number
	mov BH, 0				; video page
	mov DX, 0				; top left corner
	int 10h				; interrupt call
;........................................................................
;						; white background with green font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 0F2h			; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
	msg TMessage			; display message of what program does
	msg CRLF				; new line
	msg CW				; copywrite
;........................................................................
;						; black background with red font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 0Ch				; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
	msg RN				; copyright
;........................................................................
;						; white background with green font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 0F2h			; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
	msg TEMessage			; enter message
;........................................................................
;						; enter key to change pages
;........................................................................
	mov AH, 01h				; read character function
	int 21h				; call interrupt
	.IF(AL == 82 || AL == 114)	; if 'R' of 'r' entered
	jmp rootpage
	.ENDIF
	.IF(AL == 70 || AL == 102)	; if 'F' of 'f' entered
	jmp fatpage
	.ENDIF
	.IF(AL == 83 || AL == 115)	; if 'S' of 's' entered
	jmp sectorpage
	.ENDIF
	.IF(AL == 84 || AL == 116)	; if 'T' of 't' entered
	jmp titlepage
	.ENDIF
	jmp ender				; jump to end
;........................................................................
fatpage:
;						; display fat page
;........................................................................
;						; clear screen
;........................................................................
	mov AH, 2				; function number
	mov BH, 0				; video page
	mov DX, 0				; top left corner
	int 10h				; interrupt call
;........................................................................
;						; brown background with yellow font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 4Ah				; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
	msg FMessage			; title of FAT page
;........................................................................
;						; display jump messages
;........................................................................
	msg bjmsg				; display jump message
	mov AL, btSTRUC.bsOEM[0]
	mov bjumpa[0],AL 
	mov AL, btSTRUC.bsOEM[1]
	mov bjumpa[1],AL 
	mov AL, btSTRUC.bsOEM[2]
	mov bjumpa[2],AL   
	msg bjumpa				; display jump
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display original equipment manufacturer
;........................................................................
	msg boemsg				; display oem message
	mov AL, btSTRUC.bsOEM[0]
	mov boema[0],AL 
	mov AL, btSTRUC.bsOEM[1]
	mov boema[1],AL 
	mov AL, btSTRUC.bsOEM[2]
	mov boema[2],AL 
	mov AL, btSTRUC.bsOEM[3]
	mov boema[3],AL 
	mov AL, btSTRUC.bsOEM[4]
	mov boema[4],AL 
	mov AL, btSTRUC.bsOEM[5]
	mov boema[5],AL 
	mov AL, btSTRUC.bsOEM[6]
	mov boema[6],AL 
	mov AL, btSTRUC.bsOEM[7]
	mov boema[7],AL 
	msg boema				; display oem
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display sector size
;........................................................................
	msg bSSmsg				; display sector size message
	mov AX, btSTRUC.bsSECTSIZE	; Place number to be printed into AX.
	mov NUM, AX				; sector size
	CALL DisplayNum			; display number
;.......................................................................
;						; display beginning of bios parameter block message
;.......................................................................
	msg bbiosmsg			; display beginning of bios parameter block message
	msg CRLF				; period, carriage return, and line feed
;						; display cluster size
;.......................................................................
	msg bCSmsg				; display cluster size message
	mov AX, 0				; empty AX
	mov AL, btSTRUC.bsCLUSTSIZE; Place number to be printed into AX.
	mov NUM, AX				; cluster size
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display number of reserved sectors before fat
;.......................................................................
	msg bRSmsg				; display resserved sectors message
	mov AX, btSTRUC.bsRESSECT	; Place number to be printed into AX.
	mov NUM, AX				; # of reserved sectors
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display fat count
;.......................................................................
	msg bFCmsg				; display fat count message
	mov AX, 0				; empty AX
	mov AL, btSTRUC.bsFATCNT	; Place number to be printed into AX.
	mov NUM, AX				; fat count
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; root size
;........................................................................
	msg bRTSmsg				; display root size message
	mov AX, btSTRUC.bsROOTSIZE	; Place number to be printed into AX.
	mov NUM, AX				; root size
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; total number of sectors
;........................................................................
	msg bTOTmsg				; display total # of sectors message
	mov AX, btSTRUC.bsTOTALSECT; Place number to be printed into AX.
	mov NUM, AX				; total number of sectors
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display media
;.......................................................................
	msg bMmsg				; display media message
	mov AX, 0				; empty AX
	mov AL, btSTRUC.bsMEDIA	; Place number to be printed into AX.
	mov NUM, AX				; media ID
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display fat size
;........................................................................
	msg bFSmsg				; display fat size message
	mov AX, btSTRUC.bsFATSIZE	; Place number to be printed into AX.
	mov NUM, AX				; fat size
	CALl DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display the number of sectors per track
;........................................................................
	msg bTSmsg				; display sectors per track message
	mov AX, btSTRUC.bsTRACKSET	; Place number to be printed into AX.
	mov NUM, AX				; sectors per track
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display head count
;........................................................................
	msg bHCmsg				; display head count message
	mov AX, btSTRUC.bsHEADCNT	; Place number to be printed into AX.
	mov NUM, AX				; head count
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display hidden sectors low part
;.......................................................................
	msg bHIDSmsg			; display hidden sectors message
	mov AX, WORD PTR [btSTRUC.bsHIDENSECT]	; Place number to be printed into AX.
	mov NUM, AX				; low part of hidden sectors
	CALL DisplayNum			; display number
	msg ppmsg				; character message
;.......................................................................
;						; display hidden sectors high part
;.......................................................................
	mov AX, WORD PTR [btSTRUC.bsHIDENSECT+2]	; Place number to be printed into AX.
	mov NUM, AX				; high part of hidden sectors
	CALL DisplayNum			; display number
	msg eqmsg				; character message
;.......................................................................
;						; display huge sectors
;.......................................................................
	msg bHUGSmsg			; display huge sectors message
	mov AX, WORD PTR [btSTRUC.bsHUGESECT]	; Place number to be printed into AX.
	mov NUM, AX				; low paart of huge sectors
	CALL DisplayNum			; display number
	msg ppmsg				; character message
;.......................................................................
;						; display huge sectors high part
;.......................................................................
	mov AX, WORD PTR [btSTRUC.bsHUGESECT+2]; Place number to be printed into AX.
	mov NUM, AX				; high part of huge sectors
	CALL DisplayNum			; display number
;.......................................................................
;						; display end of bios parameter block message
;.......................................................................
	msg bebiosmsg			; display end of bios parameter block message
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display drive number
;.......................................................................
	msg bDNmsg				; display drive number message
	mov AX, 0				; empty AX
	mov AL, btSTRUC.bsDRIVENUM	; Place number to be printed into AX.
	mov NUM, AX				; drive number
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display boot sign
;.......................................................................
	msg bBSmsg				; display boot sign message
	mov AX,0				; emptty AX
	mov AL, btSTRUC.bsBOOTSIGN	; Place number to be printed into AX.
	MOV NUM, AX				; boot sign
	CALl DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display high order of volume ID or serial number
;........................................................................
	msg bVIDmsg				; display serial number message
	mov AX,WORD PTR [btSTRUC.bsVOLID + 2]	; Place number to be printed into AX.
	mov NUM, AX				; high part of volume ID
	CALL DisplayNum			; display number
;.......................................................................
;						; display low order of volume ID or serial number
;.......................................................................
	msg DASHmsg				; display dash
	mov AX,WORD PTR [btSTRUC.bsVOLID]	; Place number to be printed into AX.
	mov NUM, AX				; low part of volume ID
	CALL DisplayNum			; diaplay number
;.......................................................................
;						; display hexadecimal serial number
;.......................................................................
	msg HEXmsg				; hexadecimal serial number message
;.......................................................................
;						; convert high order serial number to hex and display
;......................................................................
	mov AX, WORD PTR [btSTRUC.bsVOLID + 2]   ; get high order of double word for serial number           
	mov HSN, AX				; frist loop 4096
	mov CX, 1
	mul CX				; DX:AX contains serial number
	mov CX, 4096			; 
	div CX	
   .IF (AX >= 0)
	mov BX, AX				; quoitient is in AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX
Hfirstloop:
	sub HSN, 4096
	Loop Hfirstloop
   .ENDIF
	mov AX, HSN				; second loop 256
	mov CX, 1
	mul CX
	mov CX, 256
	div CX
   .IF (AX >= 0)
	mov BX, AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
Hsecondloop:
	sub HSN, 256
	Loop Hsecondloop
   .ENDIF
	mov AX, HSN				; third loop 16
	mov CX, 1
	mul CX
	mov CX, 16
	div CX
   .IF (AX >= 0)
	mov BX, AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
Hthirdloop:
	sub HSN, 16
	Loop Hthirdloop
   .ENDIF
	mov BX, HSN				; no loop 1
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
;......................................................................
	msg DASHmsg				; display dash
;......................................................................
;						; convert low order serial number to hex and display
;......................................................................
	mov AX, WORD PTR [btSTRUC.bsVOLID]   ; get low order of double word for serial number           
	mov LSN, AX				; frist loop 4096
	mov CX, 1
	mul CX				; DX:AX contains serial number
	mov CX, 4096			; 
	div CX	
   .IF (AX >= 0)
	mov BX, AX				; quoitient is in AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX
Lfirstloop:
	sub LSN, 4096
	Loop Lfirstloop
   .ENDIF
	mov AX, LSN				; second loop 256
	mov CX, 1
	mul CX
	mov CX, 256
	div CX
   .IF (AX >= 0)
	mov BX, AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
Lsecondloop:
	sub LSN, 256
	Loop Lsecondloop
   .ENDIF
	mov AX, LSN				; third loop 16
	mov CX, 1
	mul CX
	mov CX, 16
	div CX
   .IF (AX >= 0)
	mov BX, AX
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
Lthirdloop:
	sub LSN, 16
	Loop Lthirdloop
   .ENDIF
	mov BX, LSN				; no loop 1
	mov DL, hexa[BX]			; character to display    
	mov AH, 02				; function 02h displays charachter in DL to output device
	int 21h
	mov CX, BX	
	msg CRLF				; period, carriage return line feed
;.......................................................................
;						; dislplay volume label
;.......................................................................
	msg bVLmsg				; display volume label message
	mov AL, btSTRUC.bsVOLABEL[0]
	mov blabela[0], AL
	mov AL, btSTRUC.bsVOLABEL[1]
	mov blabela[1], AL
	mov AL, btSTRUC.bsVOLABEL[2]
	mov blabela[2], AL
	mov AL, btSTRUC.bsVOLABEL[3]
	mov blabela[3], AL
	mov AL, btSTRUC.bsVOLABEL[4]
	mov blabela[4], AL
	mov AL, btSTRUC.bsVOLABEL[5]
	mov blabela[5], AL
	mov AL, btSTRUC.bsVOLABEL[6]
	mov blabela[6], AL
	mov AL, btSTRUC.bsVOLABEL[7]
	mov blabela[7], AL
	mov AL, btSTRUC.bsVOLABEL[8]
	mov blabela[8], AL
	mov AL, btSTRUC.bsVOLABEL[9]
	mov blabela[9], AL
	mov AL, btSTRUC.bsVOLABEL[10]
	mov blabela[10], AL
	msg blabela				; display label
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display files type
;........................................................................
	msg bFTmsg				; display files type message
	mov AL, btSTRUC.bsFILESTYPE[0]
	mov bfileta[0],AL 
	mov AL, btSTRUC.bsFILESTYPE[1]
	mov bfileta[1],AL 
	mov AL, btSTRUC.bsFILESTYPE[2]
	mov bfileta[2],AL 
	mov AL, btSTRUC.bsFILESTYPE[3]
	mov bfileta[3],AL 
	mov AL, btSTRUC.bsFILESTYPE[4]
	mov bfileta[4],AL 
	mov AL, btSTRUC.bsFILESTYPE[5]
	mov bfileta[5],AL 
	mov AL, btSTRUC.bsFILESTYPE[6]
	mov bfileta[6],AL 
	mov AL, btSTRUC.bsFILESTYPE[7]
	mov bfileta[7],AL 
	msg bfileta				; display files type
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; enter key to change pages
;........................................................................
	msg Ready				; display question if you want to see another page
	msg CRLF				; period, carriage return, and line feed
	mov AH, 01h				; read character function
	int 21h				; call interrupt
	.IF(AL == 82 || AL == 114)	; if 'R' of 'r' entered
	jmp rootpage
	.ENDIF
	.IF(AL == 70 || AL == 102)	; if 'F' of 'f' entered
	jmp fatpage
	.ENDIF
	.IF(AL == 83 || AL == 115)	; if 'S' of 's' entered
	jmp sectorpage
	.ENDIF
	.IF(AL == 84 || AL == 116)	; if 'T' of 't' entered
	jmp titlepage
	.ENDIF
	jmp ender				; jump to end
;........................................................................
rootpage:
;						; clear screen
;........................................................................
	mov AH, 2				; function number
	mov BH, 0				; video page
	mov DX, 0				; top left corner
	int 10h				; interrupt call
;........................................................................
;						; pink background with white font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 5Fh				; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
;						; title of root directory page
;........................................................................
	msg RMessage			; root directory section of program
;........................................................................
;						; display root directory name
;........................................................................
	msg rFNmsg				; display root directory message
	mov AL, rtSTRUC.deFILENAME[0]
	mov rfnamea[0],AL 
	mov AL, rtSTRUC.deFILENAME[1]
	mov rfnamea[1],AL 
	mov AL, rtSTRUC.deFILENAME[2]
	mov rfnamea[2],AL 
	mov AL, rtSTRUC.deFILENAME[3]
	mov rfnamea[3],AL 
	mov AL, rtSTRUC.deFILENAME[4]
	mov rfnamea[4],AL 
	mov AL, rtSTRUC.deFILENAME[5]
	mov rfnamea[5],AL 
	mov AL, rtSTRUC.deFILENAME[6]
	mov rfnamea[6],AL 
	mov AL, rtSTRUC.deFILENAME[7]
	mov rfnamea[7],AL 
	msg rfnamea				; display root directory name
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file extension message
;........................................................................
	msg rFEmsg				; display file extension message
	mov AL, rtSTRUC.deFILEEXT[0]
	mov rfilexta[0],AL 
	mov AL, rtSTRUC.deFILEEXT[1]
	mov rfilexta[1],AL 
	mov AL, rtSTRUC.deFILEEXT[2]
	mov rfilexta[2],AL 
	msg rfilexta			; display file extension
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute message
;........................................................................
	msg rFAmsg				; display file attribute message
	mov AL, rtSTRUC.deATRIB
	mov rata[0], AL
	msg rata				; display file attribute
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute read only message
;........................................................................
	msg ATRROmsg			; display file attribute read only message
	mov AX, 0
	mov AL ,rtSTRUC.deATRIB
	mov CX, 15
letatrroloop:
	shl AX, 1
	loop letatrroloop
	mov CX, 15
righttrroloop:
	shr AX, 1
	loop righttrroloop
	mov NUM, AX				; read only
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute hidden message
;........................................................................
	msg ATRHmsg				; display file attribute hidden message
	mov AX, 0
	mov AL, rtSTRUC.deATRIB
	mov CX, 14
leftatrhiloop:
	shl AX, 1
	loop leftatrhiloop
	mov CX, 15
rightatrhiloop:
	shr AX, 1
	loop rightatrhiloop
	mov NUM, AX				; hidden
	CALl DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute system message
;........................................................................
	msg ATRSYSmsg			; display file attribute system message
	mov AX, 0
	mov AL, rtSTRUC.deATRIB
	mov CX, 13
letatrsysloop:
	shl AX, 1
	loop letatrsysloop
	mov CX, 15
righttrsysloop:
	shr AX, 1
	loop righttrsysloop
	mov NUM, AX				; file attribute
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute volume label message
;........................................................................
	msg ATRVLmsg			; display file attribute volume label message
	mov AX, 0
	mov AL, rtSTRUC.deATRIB
	mov CX, 12
leftatrvlloop:
	shl AX, 1
	loop leftatrvlloop
	mov CX, 15
rightatrvlloop:
	shr AX, 1
	loop rightatrvlloop
	mov NUM, AX				; volume label
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute subdirectory message
;........................................................................
	msg ATRSDmsg			; display file attribute subdirectory message
	mov AX, 0
	mov AL, rtSTRUC.deATRIB
	mov CX, 11
letatrsdloop:
	shl AX, 1
	loop letatrsdloop
	mov CX, 15
righttrsdloop:
	shr AX, 1
	loop righttrsdloop
	mov NUM, AX				; subdirectory
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display file attribute new or modified message
;........................................................................
	msg ATRNMmsg			; display file attribute new or modified message
	mov AX, 0
	mov AL, rtSTRUC.deATRIB
	mov CX, 10
leftatrnmloop:
	shl AX, 1
	loop leftatrnmloop
	mov CX, 15
rightatrnmloop:
	shr AX, 1
	loop rightatrnmloop
	mov NUM, AX				; new or modified
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display directory time
;.......................................................................
	msg rDTmsg				; display directory time message
	mov AX,rtSTRUC.deTIME		; Place number to be printed into AX.
	mov NUM, AX				; time
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; get and display hour
;........................................................................
	mov AX,rtSTRUC.deTIME
	mov CX, 11
hourloop:
	shr AX, 1
	loop hourloop
	.IF (AX > 24)
	mov AX, 0
	.ENDIF
;...
	mov NUM, AX				; hour
	msg rHOURmsg			; display directory hour message
	CALL DisplayNum			; display number
	msg slash				; period, carriage return, and line feed
;.......................................................................
;						; get and display minute
;........................................................................
	mov AX,rtSTRUC.deTIME
	mov CX, 5
leftminuteloop:
	shl AX, 1
	loop leftminuteloop
	mov CX, 10
rightminuteloop:
	shr AX, 1
	loop rightminuteloop
	.IF (AX > 60)
	mov AX, 0
	.ENDIF
;...
	mov NUM, AX				; minute
	msg rMINUTEmsg			; display directory minute message
	CALL DisplayNum			; display number
	msg slash				; period, carriage return, and line feed
;.......................................................................
;						; get and display second
;........................................................................
	mov AX,rtSTRUC.deTIME
	mov CX, 11
leftsecondloop:
	shl AX, 1
	loop leftsecondloop
	mov CX, 11
rightsecondloop:
	shr AX, 1
	loop rightsecondloop
	shr AX, 1				; 2 second intervals
	.IF (AX > 60)
	mov AX, 0
	.ENDIF
;...
	mov NUM, AX				; second
	msg rSECONDmsg			; display directory second message
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display directory date
;.......................................................................
	msg rDDmsg				; display directory date message
	mov AX, rtSTRUC.deDATE		; Place number to be printed into AX.
	mov NUM, AX				; date
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; get and display month
;........................................................................
	mov AX, rtSTRUC.deDATE
	mov CX, 7
leftmonthloop:
	shl AX, 1
	loop leftmonthloop
	mov CX, 12
rightmonthloop:
	shr AX, 1
	loop rightmonthloop
	.IF (AX > 12)
	mov AX, 0
	.ENDIF
;...
	mov NUM, AX				; month
	msg rMONTHmsg			; display directory month message
	CALL DisplayNum			; display number
	msg slash				; period, carriage return, and line feed
;.......................................................................
;						; get and display day
;........................................................................
	mov AX,rtSTRUC.deDATE
	mov CX, 11
leftdayloop:
	shl AX, 1
	loop leftdayloop
	mov CX, 11
rightdayloop:
	shr AX, 1
	loop rightdayloop
	.IF (AX > 31)
	mov AX, 0
	.ENDIF
;...	
	mov NUM, AX				; day
	msg rDAYmsg				; display directory day message
	CALl DisplayNum			; display number
	msg slash				; period, carriage return, and line feed
;.......................................................................
;						; get and display year
;........................................................................
	mov AX,rtSTRUC.deDATE
	mov CX, 9
yearloop:
	shr AX, 1
	loop yearloop
	mov YR, AX
	add YR, 1980			; year relative to 1980
	.IF (YR > 2010)
	mov AX, 0
	mov YR, AX
	.ENDIF
;...
	msg rYEARmsg			; display directory year message
	mov AX,YR				; Place number to be printed into AX.
	mov NUM, AX				; year
	CALl DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display cluster number
;.......................................................................
	msg rCNmsg				; display cluster number message
	mov AX,rtSTRUC.deCLUSTNUM	; Place number to be printed into AX.
	mov NUM, AX				; 
	CALl DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display file size low part
;.......................................................................
	msg rFSmsg				; display file size message
	mov AX,WORD PTR [rtSTRUC.deFILESIZE]	; Place number to be printed into AX.
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg ppmsg				; 
;.......................................................................
;						; display file size high part
;.......................................................................
	mov AX,WORD PTR [rtSTRUC.deFILESIZE + 2]	; Place number to be printed into AX.
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg eqmsg				; 
;........................................................................
;						; display first sector of root
;.......................................................................
	msg firstsecroo			; display first sector of root message
	mov AX, FSECOFROOT		; 
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display size of root in bytes
;.......................................................................
	msg rootsizeby			; display size of root in bytes message
	mov AX, SIZEROOTBYTES		; 
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; display size of root in sectors
;.......................................................................
	msg rootsizese			; display size of root in sectors message
	mov AX, SIZEROOTSEC		; 
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; enter key to change pages
;........................................................................
	msg Ready				; display question if you want to see another page
	msg CRLF				; period, carriage return, and line feed
	mov AH, 01h				; read character function
	int 21h				; call interrupt
	.IF(AL == 82 || AL == 114)	; if 'R' of 'r' entered
	jmp rootpage
	.ENDIF
	.IF(AL == 70 || AL == 102)	; if 'F' of 'f' entered
	jmp fatpage
	.ENDIF
	.IF(AL == 83 || AL == 115)	; if 'S' of 's' entered
	jmp sectorpage
	.ENDIF
	.IF(AL == 84 || AL == 116)	; if 'T' of 't' entered
	jmp titlepage
	.ENDIF
	jmp ender				; jump to end
;........................................................................
sectorpage:
;						; display sector page
;........................................................................
;						; clear screen
;........................................................................
	mov AH, 2				; function number
	mov BH, 0				; video page
	mov DX, 0				; top left corner
	int 10h				; interrupt call
;........................................................................
;						; green background with white font
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 03Fh			; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
	msg SMessage			; title of sector count page
;........................................................................
;						; display message of what program does
;.......................................................................
	msg INOUT				; input and output
	msg LINE				; display line
;.......................................................................
;						; display bytes per sector
;.......................................................................
	msg strbps				; character message
	mov AX, bps				; 
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display clusters per sector
;.......................................................................
	msg strspc				; character message
	mov AX, spc				; 
	mov NUM, AX				; 
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display bytes per cluster
;.......................................................................
	msg strbpc				; character message
	mov AX, bps				; AX = bps
	mov bpc, AX				; bpc = AX
	mov AX, spc				; AX = spc 
	mul bpc				; calculate bytes per cluster = bps * spc
	mov NUM, AX				; NUM = AX = bps * spc ; DX = 0
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display total number of clusters
;.......................................................................
	msg strtnumclus			; character message
	mov AX, tnumclus			;
	mov NUM, AX				;
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display total number of free clusters
;.......................................................................
	msg strfreeclus			; character message
	mov AX, freeclus			;
	mov NUM, AX				;
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;.......................................................................
;						; display total number of used clusters
;.......................................................................
	msg strusedclus			; character message
	mov AX, tnumclus			; calculate total used clusters
	mov BX, freeclus			; calculate total used clusters
	sub AX, BX				; calculate total used clusters
	mov NUM, AX				; calculate total used clusters
	CALL DisplayNum			; display number
	msg CRLF				; period, carriage return, and line feed
;........................................................................
;						; enter key to change pages
;........................................................................
	msg Ready				; display question if you want to see another page
	msg CRLF				; period, carriage return, and line feed
	mov AH, 01h				; read character function
	int 21h				; call interrupt
	.IF(AL == 82 || AL == 114)	; if 'R' of 'r' entered
	jmp rootpage
	.ENDIF
	.IF(AL == 70 || AL == 102)	; if 'F' of 'f' entered
	jmp fatpage
	.ENDIF
	.IF(AL == 83 || AL == 115)	; if 'S' of 's' entered
	jmp sectorpage
	.ENDIF
	.IF(AL == 84 || AL == 116)	; if 'T' of 't' entered
	jmp titlepage
	.ENDIF
	jmp ender				; jump to end
;........................................................................
ender:
	msg enoq				; you chose to exit
;........................................................................
;						; restore screen
;........................................................................
	mov AH,9				; function number
	mov CX, 2000			; number of characters of output
	mov BL, 0Fh				; color code
	mov AL, " "				; blank characters
	int 10h				; call interrupt
;........................................................................
;						; make noise
;........................................................................
	mov CX,9     			; number of signals produced loop count
prod: mov BX, CX             		; number of current signal
	shl BX, 1				; multiply number by 2 to obtain offset
	mov DI, WORD PTR freq[BX]	; get frequency of current signal
	mov BX,10				; duration - 10 hundreths of second
;.......................................................................
	push AX				; push registers onto stack
	push CX
	push DX
	push DS
	push ES
	push SI
      in AL, 61h   	         	; input port B's address 61h into accumulator
      mov CL, AL   	         	; copy port B's address in count register
      or AL, 3              		; turn on speaker and timer by putting 3 or 11 binary into accumulator
      out 61h, AL        	    	; and then output from accumulator to port B
      mov AL, 0B6h    	       	; set for channel 2 by first putting 0B6h into accumulator
      out 43h, AL      		     	; and then output command from register to port
      mov DX, 14h    	        	; prevents division by zero
      mov AX, 4F38h  	        	; divisor of frequency
      div DI   	             	; frequency in di is divided by 144F38h
      out 42h, AL    	        	; lower byte of result of frequency division is sent to timer port
      mov AL, AH           	  	; copy high bits to low bits
      out 42h, AL         	   	; higher byte of result of frequency division is sent to timer port
;...................................................................
;  					    	; generation of sound delay 
;...................................................................
      mov AX, 91             		; accumulator contains multiplier
      mul BX                		; AX = BX * 91 and result is put in DX:AX since it is a word
      mov BX, 500            		; divisor
      div BX                		; DX:AX dividend / 500 = result in AX, remainder in DX 
      mov BX, AX             		; save delay result in BX
      mov AH, 0              		; read clock tick function which is incremenyed 18.2 times / second
      int 1Ah               		; read timer interrupt
      add DX, BX             		; DX = DX + BX
      mov BX, DX             		; DX = BX
Cycle:
	int 1Ah               		; begin loop and read clock interrupt
      cmp DX, BX             		; compare to see if time passed
      jne Cycle             		; end loop
      in AL, 61h            		; read mode of port B
      mov AL, CL             		; previous mode or port B
      and AL, 0FCh           		; prepare to turn offf speaker
      out 61h, AL            		; restore original contents to port B to turn speaker off 
;.......................................................................
;						;  Restore Registers
;.......................................................................
	pop SI
	pop ES
	pop DS
	pop DX
	pop CX
	pop AX
	loop prod                	; next signal end of loop
;........................................................................
;						; terminate program
;........................................................................
	mov AX,4C00h			; termination function
	int 21h				; termination interupt
;........................................................................
;						; Display Number Procedure
;........................................................................
	DisplayNum proc
	push AX
	push BX
	push CX
	push DX
	mov AX, NUM
	mov BX, 10
	mov CX, 0
DNexDiv:
	mov DX, 0
	div BX
	push DX
	inc CX
	cmp AX, 0
	jne DNexDiv
	mov AX, 200h
DOutSym: pop DX
	add DL, '0'
	int 21h
	loop DOutSym
	pop DX
	pop CX
	pop BX
	pop AX
	ret
	DisplayNum endp
;........................................................................
CodeSeg    ends       	      	; end algorithm
;........................................................................
end  start 			      	; end program


